from lab_utils import *
import math


def test_es_1(g):
    try:
        f1 = g["move_cursor"]
        f1(99, 98)
        f1ok = g["x"]==99 and g["y"]==98
    except:
        f1ok = False
        
    try:
        g["x"]=-1
        g["y"]=-2
        f2 = g["reset_cursor"]
        f2()
        f2ok = g["x"]==0 and g["y"]==0
    except:
        f2ok = False
        
    test_cases(("move_cursor", f1ok), ("reset_cursor", f2ok))
    
    
def test_es_3(g):
    function_test_cases(g, "sort_grades", 
(('Programming and computer architectures',),
  [(1, 'Ford Prefect', 'Programming and computer architectures', 30, True),
   (5, 'Slartibartfast', 'Programming and computer architectures', 30, False),
   (99, 'Marvin', 'Programming and computer architectures', 25, False),
   (4, 'Trillian', 'Programming and computer architectures', 24, False),
   (2, 'Zaphod Beeblebrox', 'Programming and computer architectures', 23, False),
   (42, 'Arthur Dent', 'Programming and computer architectures', 18, False)]),
 (('Fundamentals of accounting',),
  [(4, 'Trillian', 'Fundamentals of accounting', 30, False),
   (42, 'Arthur Dent', 'Fundamentals of accounting', 30, False),
   (2, 'Zaphod Beeblebrox', 'Fundamentals of accounting', 28, False),
   (5, 'Slartibartfast', 'Fundamentals of accounting', 24, False),
   (1, 'Ford Prefect', 'Fundamentals of accounting', 23, False),
   (99, 'Marvin', 'Fundamentals of accounting', 18, False)]),
 (('Operating systems, networks and web',),
  [(4, 'Trillian', 'Operating systems, networks and web', 30, True),
   (2, 'Zaphod Beeblebrox', 'Operating systems, networks and web', 26, False),
   (1, 'Ford Prefect', 'Operating systems, networks and web', 24, False),
   (5, 'Slartibartfast', 'Operating systems, networks and web', 23, False),
   (99, 'Marvin', 'Operating systems, networks and web', 22, False),
   (42, 'Arthur Dent', 'Operating systems, networks and web', 18, False)]),
 (('Fundamentals of management and organization',),
  [(2, 'Zaphod Beeblebrox', 'Fundamentals of management and organization', 30, True),
   (1, 'Ford Prefect', 'Fundamentals of management and organization', 30, False),
   (99, 'Marvin', 'Fundamentals of management and organization', 26, False),
   (4, 'Trillian', 'Fundamentals of management and organization', 24, False),
   (5, 'Slartibartfast', 'Fundamentals of management and organization', 19, False)]),
 (('Database systems',),
  [(2, 'Zaphod Beeblebrox', 'Database systems', 30, False),
   (99, 'Marvin', 'Database systems', 27, False),
   (5, 'Slartibartfast', 'Database systems', 25, False),
   (1, 'Ford Prefect', 'Database systems', 24, False),
   (42, 'Arthur Dent', 'Database systems', 18, False)]),
 (('Fundamentals of finance and banking',),
  [(5, 'Slartibartfast', 'Fundamentals of finance and banking', 30, False),
   (42, 'Arthur Dent', 'Fundamentals of finance and banking', 29, False),
   (2, 'Zaphod Beeblebrox', 'Fundamentals of finance and banking', 28, False),
   (99, 'Marvin', 'Fundamentals of finance and banking', 23, False),
   (1, 'Ford Prefect', 'Fundamentals of finance and banking', 22, False),
   (4, 'Trillian', 'Fundamentals of finance and banking', 20, False)])
)

MAX_LEN = 142    

def _process_es(func):
    try:
        code = input(f'Enter the function body (single-line, max {MAX_LEN} characters)')
        code = code.strip()
        if len(code) > MAX_LEN:
            return test_cases(("Too long!", False))
        
        if "\n" in code or "\r" in code:
            return test_cases(("New-line character present!", False))

        if not code.startswith("return"):
            return test_cases(("The function body does not start with return", False))
        
        code = code[6:]
        
        return func(code)
        
    except Exception as ex:
        return test_cases((f"Error: {ex}", False))

    
def test_es_4(g):
    
    def func(code):
        def f(course):
            return eval(code, {"grades": g["grades"], "course": course})                                          
        return test_es_2({"sort_grades": f})
        
    return _process_es(func)
    
    
def test_es_5(g):
    
    expected_res = [
        (1, 25.5),
        (2, 27.5),
        (4, 25.6),
        (5, 25.166666666666668),
        (42, 22.6),
        (99, 23.5),
    ]
    
    def func(code):
        def f():
            return eval(code, {"grades": g["grades"]}) 
        res = f()        
        
        ok = False
        if len(res) == len(expected_res):
            ok = all(id1==id2 and math.isclose(a1, a2, abs_tol = 0.01) for (id1, a1), (id2, a2) in zip(sorted(res), expected_res))
        
        return test_cases((f"Test {'OK' if ok else 'FAILED'}", ok))
        
    return _process_es(func)