from lab_utils import *
import PIL.Image
import IPython.display
import numpy as np
import math
import io
from ipywidgets import HBox, Image


def show_images(*imgs):
    l = []
    for i in imgs:
        if isinstance(i, str):
            file = open(i, "rb")
            image_widget = Image(value=file.read())
        else:
            ba = io.BytesIO()
            PIL.Image.fromarray(i).save(ba, format='PNG')
            image_widget = Image(value=ba.getvalue())        
        l.append(image_widget)
    IPython.display.display(HBox(l))

    
def show_matrix_as_image(img):
    IPython.display.display(PIL.Image.fromarray(img.astype(np.uint8)))


def test_es_1(d):
    test_predicates_on_global_vars(d,
        ('np', lambda x: x.__name__ == np.__name__),
        ('x', lambda x: np.array_equal(x, np.array([-3.  , -2.25, -1.5 , -0.75,  0.  ,  0.75,  1.5 ,  2.25,  3.  ]))),
        ('y', lambda x: np.array_equal(x, np.array([[-2.  ], [-0.75], [ 0.5 ], [ 1.75], [ 3.  ]]))),
        ('z', lambda x: np.all(x == 0) and x.shape == (5,5)),
    )

def test_es_2(d):
    test_predicates_on_global_vars(d,
        ('squares', lambda x: x.shape == (100,) and x.sum() == -5050),
        ('cubes', lambda x: x.shape == (100,) and x.sum() == 25502500),
        ('r', lambda x: x.shape == (100,) and math.isclose(0.68817, x.sum(), abs_tol = 0.001)),
        ('s', lambda x: math.isclose(0.68817, x, abs_tol = 0.001)),
    )
    
_color_map = np.array([
(0, 0, 0),
(66, 30, 15),
(25, 7, 26),
(9, 1, 47),
(4, 4, 73),
(0, 7, 100),
(12, 44, 138),
(24, 82, 177),
(57, 125, 209),
(134, 181, 229),
(211, 236, 248),
(241, 233, 191),
(248, 201, 95),
(255, 170, 0),
(204, 128, 0),
(153, 87, 0),
(106, 52, 3),
], np.uint8)    

def apply_color_map(img):
    return _color_map[img]

